import requests


from api_1105 import log
from api_1105.common_.l_basic_ini import Readbasicini
from api_1105.common_.l_db import DB


class RequestsMethod:
    def __init__(self):
        self.db = DB()
        self.bpm_session = requests.sessions.Session()
        login_data = {"username": "admin","password": "QKpkgIwnyACrUXQrQVRaSUbhPSOsKnj5hoRN5LGKHT3NmLCwGIN+aGa981YZtlLoEfpVvGDnILn0QU09VHSkgL+Or6oTG1E8OtVTmAEjivAe/a4zLPwd/OfvKYIYbBP5ExZyy+wlVTbLgDfqkuKPGOMPPSLlZWLfvG7yzdc+CyE="}
        login_url = Readbasicini().get_host("bpm") + "/auth"
        token = self.bpm_session.request(method="post", url=login_url, json=login_data).json()["token"]
        self.bpm_session.headers["Authorization"] = "Bearer " + token



    def request_all(self, req_method, req_url, req_mime=None, req_case=None, sql_type=None, sql_data=None, update_key=None):
        if sql_type == "delete":
            # 使用DB类对象，执行删除sql语句
            self.db.delete(sql_data)

        # 判断sql语句类型是否为select，如果是，需要执行查询sql语句，并获取查询的结果，将查询的结果更新到用例数据中
        elif sql_type == "select":
            # 使用DB类对象，执行查询sql语句，并获取查询结果
            select_res = self.db.select(sql_data)
            # 将查询结果更新到用例数据中
            req_case[update_key] = select_res
            # print("用例数据：", req_case)
            # print("更新的key：", update_key)
            # print("查询结果：", select_res)
            # print("用例数据更新之后：", req_case)
        elif sql_type == "select|delete" or sql_type == "delete|select":
            self.db.delete(sql_data["delete"])
            select_result = self.db.select(sql_data["select"])
            req_case[update_key] = select_result


        # 判断请求的媒体类型的值是否为application/x-www-form-urlencoded或者为x-www-form-urlencoded、form 使用data传参
        if req_mime == "application/x-www-form-urlencoded" or req_mime == 'x-www-form-urlencoded' or req_mime == "form":
            # 使用Session对象发送请求，并返回服务器响应的结果
            return self.bpm_session.request(method=req_method, url=req_url, data=req_case)

        # 判断请求的媒体类型的值是否为application/json或者为json使用json传参
        elif req_mime == "application/json" or req_mime == 'json':
            # 使用Session对象发送请求，并返回服务器响应的结果
            return self.bpm_session.request(method=req_method, url=req_url, json=req_case)

        # 判断请求的媒体类型的值是否为multipart/form-data或者为form-data使用files传参
        elif req_mime == "multipart/form-data" or req_mime == 'form-data':
            # 使用Session对象发送请求，并返回服务器响应的结果
            return self.bpm_session.request(method=req_method, url=req_url, files=req_case)

        # 判断请求的媒体类型的值是否为query使用params传参
        elif req_mime == "query":
            return self.bpm_session.request(method=req_method, url=req_url, params=req_case)

        # 判断请求的媒体类型的值是否为None, 表示没有传参
        elif req_mime is None:
            # 使用Session对象发送请求，并返回服务器响应的结果
            return self.bpm_session.request(method=req_method, url=req_url)

            # 判断请求的媒体类型是否为：query|json 或者 json|query 如果是，表示在地址栏和请求体中同时传参，请求体还是以json类型传参。
        elif req_mime == "query|json" or req_mime == "json|query":
            # requests可以在地址栏和请求体同时传参，请求体传参根据不同的媒体类型选择不同关键字传参，地址使用params
            return self.bpm_session.request(method=req_method, url=req_url, params=req_case["query"],
                                            json=req_case["body"])

        else:
            log.error(f"方法：request_all，传入的媒体类型为：{req_mime}, 没有符合的判断分支，可以自行封装，也可以继承之后覆盖")
            raise ValueError("没有符合的判断分支，可以自行封装，也可以继承之后覆盖")

# if __name__ == '__main__':
#     datas = [
#         'DELETE',
#         'http://36.139.193.99:8088/api/demension/v1/dem/deleteDemByIds',
#         'query',
#         {'ids': '需要更新'},
#         {'state': True, 'message': '删除维度成功！'},
#         'SELECT ID_ FROM uc_demension WHERE CODE_="testAddDem";',
#         'select',
#         'ids'
#     ]
#     req = RequestsMethod()
#     req.request_all(req_method=datas[0], req_url=datas[1], req_mime=datas[2], req_case=datas[3], sql_type=datas[-2], sql_data=datas[-3], update_key=datas[-1])
